commit 63e15eac4f443fa53565d1e4fb9611cdd7814f28
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Thu Jul 8 22:46:33 2021 +0200

    2.8.2

 NEWS                   | 16 ++++++++++++++++
 configure.ac           |  2 +-
 docs/harfbuzz-docs.xml |  1 +
 meson.build            |  2 +-
 src/hb-blob.cc         |  4 ++--
 src/hb-set.cc          |  2 +-
 src/hb-version.h       |  4 ++--
 7 files changed, 24 insertions(+), 7 deletions(-)

commit eee36bbea3c96ab3c84a2b928cb254d9e1860069
Author: Caleb Maclennan <caleb@alerque.com>
Date:   Thu Jul 8 21:19:57 2021 +0300

    [releasing] Format notes as Markdown checklist for pasting in GH PR/Issue

 RELEASING.md | 49 ++++++++++++++++++++++++-------------------------
 1 file changed, 24 insertions(+), 25 deletions(-)

commit eda5dcdb3eb1b85d914602c27a480ba3a16e43fb
Author: Caleb Maclennan <caleb@alerque.com>
Date:   Thu Jul 8 21:10:35 2021 +0300

    [releasing] Drop obsolete release process items

 RELEASING.md | 8 +-------
 1 file changed, 1 insertion(+), 7 deletions(-)

commit 2337f0d047f2561c13b29b70ad783bbf0d286654
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jul 8 10:58:50 2021 -0600

    Internally use hb_malloc/.../hb_free instead of malloc/.../free
    
    Redefining those stock names as macros was conflicting with gcc 10
    headers.
    
    Fixes https://github.com/harfbuzz/harfbuzz/issues/3044

 src/hb-array.hh                            |  4 +--
 src/hb-blob.cc                             | 32 ++++++++---------
 src/hb-buffer.cc                           | 10 +++---
 src/hb-common.cc                           | 12 +++----
 src/hb-directwrite.cc                      |  4 +--
 src/hb-draw.cc                             |  2 +-
 src/hb-face.cc                             | 18 +++++-----
 src/hb-font.cc                             | 58 +++++++++++++++---------------
 src/hb-ft.cc                               | 24 ++++++-------
 src/hb-gdi.cc                              |  6 ++--
 src/hb-gobject-structs.cc                  |  4 +--
 src/hb-graphite2.cc                        | 10 +++---
 src/hb-machinery.hh                        |  6 ++--
 src/hb-map.cc                              |  2 +-
 src/hb-map.hh                              |  6 ++--
 src/hb-object.hh                           |  8 ++---
 src/hb-ot-color-cbdt-table.hh              |  2 +-
 src/hb-ot-glyf-table.hh                    |  4 +--
 src/hb-ot-layout-gsubgpos.hh               |  4 +--
 src/hb-ot-name-table.hh                    |  4 +--
 src/hb-ot-post-table.hh                    |  6 ++--
 src/hb-ot-shape-complex-arabic-fallback.hh |  8 ++---
 src/hb-ot-shape-complex-arabic.cc          |  4 +--
 src/hb-ot-shape-complex-hangul.cc          |  4 +--
 src/hb-ot-shape-complex-indic.cc           |  4 +--
 src/hb-ot-shape-complex-khmer.cc           |  4 +--
 src/hb-ot-shape-complex-use.cc             |  6 ++--
 src/hb-ot-tag.cc                           |  4 +--
 src/hb-pool.hh                             |  4 +--
 src/hb-repacker.hh                         |  4 +--
 src/hb-serialize.hh                        |  6 ++--
 src/hb-set.cc                              |  2 +-
 src/hb-shape-plan.cc                       | 12 +++----
 src/hb-shape-plan.hh                       |  2 +-
 src/hb-shape.cc                            |  4 +--
 src/hb-shaper.cc                           |  4 +--
 src/hb-subset-input.cc                     |  2 +-
 src/hb-subset-plan.cc                      | 10 +++---
 src/hb-unicode.cc                          |  2 +-
 src/hb-uniscribe.cc                        | 24 ++++++-------
 src/hb-vector.hh                           |  4 +--
 src/hb.hh                                  | 13 ++++---
 42 files changed, 179 insertions(+), 174 deletions(-)

commit bb48bf52a4645abda6fe98cc5ee33beab69931a5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jul 8 10:53:45 2021 -0600

    Rename misc uses of "free"
    
    In preparation for fixing https://github.com/harfbuzz/harfbuzz/issues/3044

 src/hb-array.hh                |  4 ++--
 src/hb-cache.hh                |  2 +-
 src/hb-common.cc               | 10 ++++------
 src/hb-iter.hh                 |  2 +-
 src/hb-ot-face-table-list.hh   |  2 +-
 src/hb-ot-glyf-table.hh        |  2 +-
 src/hb-ot-layout-gpos-table.hh |  2 +-
 src/hb-ot-layout.cc            |  3 ++-
 src/hb-pool.hh                 |  4 ++--
 src/hb-serialize.hh            |  2 +-
 src/hb-set.hh                  |  2 +-
 src/hb-shape-plan.cc           |  4 ++--
 src/hb-shape-plan.hh           |  2 +-
 src/test-repacker.cc           |  8 ++++----
 14 files changed, 24 insertions(+), 25 deletions(-)

commit 7416faceeb7a875ba7316cee124edee2d59ea8d0
Author: Qunxin Liu <qxliu@google.com>
Date:   Wed Jul 7 11:27:49 2021 -0700

    [subset] fuzzer fix: https://oss-fuzz.com/testcase-detail/5715464591376384

 src/hb-ot-color-cpal-table.hh                      |  49 +++++++--------------
 ...ase-minimized-hb-subset-fuzzer-5715464591376384 | Bin 0 -> 2116 bytes
 2 files changed, 15 insertions(+), 34 deletions(-)

commit 895acdf7c7ac128cc1540fa251f772323f0042e8
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Wed Jun 23 14:53:28 2021 +0200

    [ci] Don’t build Cairo subproject with FontConfig on win32 cross-build
    
    We don’t need it and it breaks the build because FontConfig renamed its
    master branch and the released version of Cairo wants to build
    FontConfig from master branch.

 .ci/build-win32.sh | 16 ++++++++++++++--
 1 file changed, 14 insertions(+), 2 deletions(-)

commit 0da9158f620077ec46dcdfa4c1556253b23337eb
Author: Garret Rieger <grieger@google.com>
Date:   Tue Jun 29 14:23:37 2021 -0700

    [subset] Remove OffsetTo::serialize().
    
    Convert remaining uses of it to serialize_serialize() which correctly uses the object packer.

 src/hb-open-type.hh                                   |   4 ----
 src/hb-ot-layout-common.hh                            |   8 ++++----
 src/hb-ot-var-hvar-table.hh                           |  14 ++++++++------
 test/api/fonts/AdobeVFPrototype.abc.otf               | Bin 6900 -> 5164 bytes
 test/api/fonts/AdobeVFPrototype.ac.nohints.otf        | Bin 4212 -> 4384 bytes
 .../api/fonts/AdobeVFPrototype.ac.nosubrs.nohints.otf | Bin 4092 -> 4268 bytes
 test/api/fonts/AdobeVFPrototype.ac.nosubrs.otf        | Bin 6284 -> 4464 bytes
 test/api/fonts/AdobeVFPrototype.ac.otf                | Bin 6408 -> 4584 bytes
 test/api/fonts/AdobeVFPrototype.ac.retaingids.otf     | Bin 6412 -> 4584 bytes
 .../fonts/SourceSansVariable-Roman-modHVAR.abc.ttf    | Bin 3260 -> 3124 bytes
 .../api/fonts/SourceSansVariable-Roman-modHVAR.ac.ttf | Bin 3032 -> 2892 bytes
 test/api/fonts/SourceSansVariable-Roman.abc.ttf       | Bin 3240 -> 3196 bytes
 .../fonts/SourceSansVariable-Roman.ac.retaingids.ttf  | Bin 2616 -> 2976 bytes
 test/api/fonts/SourceSansVariable-Roman.ac.ttf        | Bin 3028 -> 2964 bytes
 test/api/fonts/SourceSerifVariable-Roman-VVAR.abc.ttf | Bin 5632 -> 3588 bytes
 .../SourceSerifVariable-Roman-VVAR.ac.retaingids.ttf  | Bin 5288 -> 3244 bytes
 test/api/fonts/SourceSerifVariable-Roman-VVAR.ac.ttf  | Bin 3224 -> 3224 bytes
 17 files changed, 12 insertions(+), 14 deletions(-)

commit 0969614865a8664aaa13759e2d60caab0bd7df3a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Jun 26 08:52:53 2021 -0600

    [ot-shape] Rewrite loop without foreach_grapheme()
    
    We were not using the graphemes, and that's costlier than just for().

 src/hb-ot-shape.cc | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit eee7b459ee18cd722e9ba0d030c983e66b6e7777
Author: Qunxin Liu <qxliu@google.com>
Date:   Thu Jun 24 10:17:46 2021 -0700

    [subset] add option --no-prune-unicode-ranges

 src/hb-ot-os2-table.hh                                 |   1 +
 src/hb-subset-input.cc                                 |  14 ++++++++++++++
 src/hb-subset-input.hh                                 |   1 +
 src/hb-subset-plan.cc                                  |   1 +
 src/hb-subset-plan.hh                                  |   1 +
 src/hb-subset.h                                        |   7 +++++++
 ...aa-Regular-new.no-prune-unicode-ranges.61,62,63.ttf | Bin 0 -> 7060 bytes
 ...ortaa-Regular-new.no-prune-unicode-ranges.61,63.ttf | Bin 0 -> 6692 bytes
 ...omfortaa-Regular-new.no-prune-unicode-ranges.61.ttf | Bin 0 -> 6328 bytes
 ...omfortaa-Regular-new.no-prune-unicode-ranges.62.ttf | Bin 0 -> 6200 bytes
 ...omfortaa-Regular-new.no-prune-unicode-ranges.63.ttf | Bin 0 -> 6256 bytes
 ...ew.no-prune-unicode-ranges.retain-all-codepoint.ttf | Bin 0 -> 220928 bytes
 ...Regular-subset.no-prune-unicode-ranges.61,62,63.ttf | Bin 0 -> 4128 bytes
 ...jo-Regular-subset.no-prune-unicode-ranges.61,63.ttf | Bin 0 -> 3580 bytes
 ...ongjo-Regular-subset.no-prune-unicode-ranges.61.ttf | Bin 0 -> 3156 bytes
 ...ongjo-Regular-subset.no-prune-unicode-ranges.62.ttf | Bin 0 -> 3180 bytes
 ...ongjo-Regular-subset.no-prune-unicode-ranges.63.ttf | Bin 0 -> 3048 bytes
 ...et.no-prune-unicode-ranges.retain-all-codepoint.ttf | Bin 0 -> 9524 bytes
 ...to-Regular.abc.no-prune-unicode-ranges.61,62,63.ttf | Bin 0 -> 2452 bytes
 ...oboto-Regular.abc.no-prune-unicode-ranges.61,63.ttf | Bin 0 -> 2260 bytes
 .../Roboto-Regular.abc.no-prune-unicode-ranges.61.ttf  | Bin 0 -> 2048 bytes
 .../Roboto-Regular.abc.no-prune-unicode-ranges.62.ttf  | Bin 0 -> 1916 bytes
 .../Roboto-Regular.abc.no-prune-unicode-ranges.63.ttf  | Bin 0 -> 1972 bytes
 ...bc.no-prune-unicode-ranges.retain-all-codepoint.ttf | Bin 0 -> 2452 bytes
 test/subset/data/profiles/no-prune-unicode-ranges.txt  |   1 +
 test/subset/data/tests/basics.tests                    |   1 +
 util/options-subset.cc                                 |   1 +
 27 files changed, 28 insertions(+)

commit c3be28ea26cd23011440db7e6afaf4412e5d705d
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Wed Jun 23 17:39:23 2021 +0200

    [ot-shape] Numeric runs native direction is LTR
    
    See inline comments. Slightly modified version of the code from Jonathan
    Kew on the linked issue.
    
    Fixes https://github.com/harfbuzz/harfbuzz/issues/501

 src/hb-ot-shape.cc                                 |  29 +++++++++++++++++++++
 src/hb-unicode.hh                                  |   7 +++++
 test/shaping/data/in-house/Makefile.sources        |   1 +
 .../3b791518a9ba89675df02f1eefbc9026a50648a6.ttf   | Bin 0 -> 3144 bytes
 .../a6b17da98b9f1565ba428719777bbf94a66403c1.ttf   | Bin 0 -> 3676 bytes
 .../b082211be29a3e2cf91f0fd43497e40b2a27b344.ttf   | Bin 0 -> 4800 bytes
 .../e5ff44940364c2247abed50bdda30d2ef5aedfe4.ttf   | Bin 0 -> 2548 bytes
 test/shaping/data/in-house/meson.build             |   1 +
 test/shaping/data/in-house/tests/digits.tests      |   5 ++++
 9 files changed, 43 insertions(+)

commit 71a62966202012300a2cf2c8fbaae32354d136ba
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Wed Jun 23 18:16:56 2021 +0200

    [tests] Make record-test.sh work with .otf files
    
    It hard-codes the file extension, but fonttools sunset will use .otf for
    CFF fonts, so hard-code the output file from subset as well.

 test/shaping/record-test.sh | 10 ++++++----
 1 file changed, 6 insertions(+), 4 deletions(-)

commit cc9bb294919e846ef8a0731b5e9f304f95ef3bb8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Jun 20 18:47:03 2021 -0600

    [blob] Fix-up recent mistake in hb_blob_create() destroy(user_data)
    
    https://github.com/harfbuzz/harfbuzz/pull/3026#discussion_r653437491

 src/hb-blob.cc | 4 ++++
 1 file changed, 4 insertions(+)

commit bc06af977fc89b8b25bfd7180d010b915811c0d8
Author: Garret Rieger <grieger@google.com>
Date:   Wed Jun 16 15:49:14 2021 -0700

    [subset] speed up feature collection when tags are specified.
    
    Precompute a feature index filter to avoid needing to iterate the feature tag list for each encountered feature index. For this particular fuzzer case speeds up feature collection from 50s to 2s.

 src/hb-ot-layout.cc                                |  98 +++++++++++++--------
 ...ase-minimized-hb-subset-fuzzer-5241922561114112 | Bin 0 -> 638237 bytes
 2 files changed, 63 insertions(+), 35 deletions(-)

commit 14f220b76159a2f2d926029e32b3fe975d1dc525
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Sun Jun 20 18:59:13 2021 +0200

    [directwrite] Support feature ranges
    
    Code copied from hb-uniscribe.cc and adapted to use DirectWrite types.
    May be there is a better way to de-duplicate the code, though I'm not
    exactly sure how or if it is worth it.

 src/hb-directwrite.cc | 198 +++++++++++++++++++++++++++++++++++++++++++++-----
 1 file changed, 180 insertions(+), 18 deletions(-)

commit d2397d91f30c7eda0a446cefd623d78e16cf7268
Author: Garret Rieger <grieger@google.com>
Date:   Fri Jun 18 18:12:19 2021 -0700

    [subset] Add additional colrv1 subsetting tests that has a glyph with components.

 test/subset/data/Makefile.am                            |   1 +
 test/subset/data/Makefile.sources                       |   1 +
 .../NotoColrEmojiGlyf-Regular.subset.default.1f35e.ttf  | Bin 0 -> 3004 bytes
 .../NotoColrEmojiGlyf-Regular.subset.default.1f696.ttf  | Bin 0 -> 3752 bytes
 ...Glyf-Regular.subset.drop-hints-retain-gids.1f35e.ttf | Bin 0 -> 3516 bytes
 ...Glyf-Regular.subset.drop-hints-retain-gids.1f696.ttf | Bin 0 -> 5048 bytes
 ...otoColrEmojiGlyf-Regular.subset.drop-hints.1f35e.ttf | Bin 0 -> 3004 bytes
 ...otoColrEmojiGlyf-Regular.subset.drop-hints.1f696.ttf | Bin 0 -> 3752 bytes
 ...toColrEmojiGlyf-Regular.subset.retain-gids.1f35e.ttf | Bin 0 -> 3516 bytes
 ...toColrEmojiGlyf-Regular.subset.retain-gids.1f696.ttf | Bin 0 -> 5048 bytes
 .../data/fonts/NotoColrEmojiGlyf-Regular.subset.ttf     | Bin 0 -> 71896 bytes
 test/subset/data/tests/colrv1.notoemoji.tests           |  12 ++++++++++++
 test/subset/meson.build                                 |   1 +
 13 files changed, 15 insertions(+)

commit 26c80adb61938288b3954b907fe6ddbb430fa468
Author: Garret Rieger <grieger@google.com>
Date:   Fri Jun 18 14:14:20 2021 -0700

    [subset] do colrv1 glyph closure before glyf composite closure.

 src/hb-subset-plan.cc | 21 +++++++++++----------
 1 file changed, 11 insertions(+), 10 deletions(-)

commit d07f789ae3997ee95923525af56627d4be4a90e4
Author: Qunxin Liu <qxliu@google.com>
Date:   Wed Jun 9 15:36:40 2021 -0700

    [subset] support option "--notdef-outline"

 src/hb-ot-glyf-table.hh                            |   5 ++++-
 src/hb-ot-var-gvar-table.hh                        |   4 ++--
 src/hb-subset-input.cc                             |  15 +++++++++++++++
 src/hb-subset-input.hh                             |  14 ++++++++------
 src/hb-subset-plan.cc                              |   1 +
 src/hb-subset-plan.hh                              |   1 +
 src/hb-subset.h                                    |   7 +++++++
 .../Comfortaa-Regular-new.default.61,62,63.ttf     | Bin 7652 -> 7060 bytes
 .../basics/Comfortaa-Regular-new.default.61,63.ttf | Bin 7284 -> 6692 bytes
 .../basics/Comfortaa-Regular-new.default.61.ttf    | Bin 6920 -> 6328 bytes
 .../basics/Comfortaa-Regular-new.default.62.ttf    | Bin 6796 -> 6200 bytes
 .../basics/Comfortaa-Regular-new.default.63.ttf    | Bin 6844 -> 6256 bytes
 ...aa-Regular-new.default.retain-all-codepoint.ttf | Bin 221524 -> 220928 bytes
 ...Regular-new.drop-hints-retain-gids.61,62,63.ttf | Bin 5104 -> 4608 bytes
 ...aa-Regular-new.drop-hints-retain-gids.61,63.ttf | Bin 4808 -> 4312 bytes
 ...ortaa-Regular-new.drop-hints-retain-gids.61.ttf | Bin 4220 -> 3724 bytes
 ...ortaa-Regular-new.drop-hints-retain-gids.62.ttf | Bin 4396 -> 3900 bytes
 ...ortaa-Regular-new.drop-hints-retain-gids.63.ttf | Bin 4468 -> 3972 bytes
 ...drop-hints-retain-gids.retain-all-codepoint.ttf | Bin 190296 -> 189800 bytes
 .../Comfortaa-Regular-new.drop-hints.61,62,63.ttf  | Bin 3100 -> 2600 bytes
 .../Comfortaa-Regular-new.drop-hints.61,63.ttf     | Bin 2792 -> 2296 bytes
 .../basics/Comfortaa-Regular-new.drop-hints.61.ttf | Bin 2472 -> 1976 bytes
 .../basics/Comfortaa-Regular-new.drop-hints.62.ttf | Bin 2396 -> 1900 bytes
 .../basics/Comfortaa-Regular-new.drop-hints.63.ttf | Bin 2460 -> 1968 bytes
 ...Regular-new.drop-hints.retain-all-codepoint.ttf | Bin 190252 -> 189756 bytes
 .../basics/Comfortaa-Regular-new.gids.61,62,63.ttf | Bin 8580 -> 7988 bytes
 .../basics/Comfortaa-Regular-new.gids.61,63.ttf    | Bin 8220 -> 7628 bytes
 .../basics/Comfortaa-Regular-new.gids.61.ttf       | Bin 7848 -> 7256 bytes
 .../basics/Comfortaa-Regular-new.gids.62.ttf       | Bin 7772 -> 7184 bytes
 .../basics/Comfortaa-Regular-new.gids.63.ttf       | Bin 7776 -> 7180 bytes
 ...ortaa-Regular-new.gids.retain-all-codepoint.ttf | Bin 221524 -> 220928 bytes
 ...gular-new.keep-all-layout-features.61,62,63.ttf | Bin 8100 -> 7504 bytes
 ...-Regular-new.keep-all-layout-features.61,63.ttf | Bin 7736 -> 7140 bytes
 ...taa-Regular-new.keep-all-layout-features.61.ttf | Bin 7360 -> 6772 bytes
 ...taa-Regular-new.keep-all-layout-features.62.ttf | Bin 6796 -> 6200 bytes
 ...taa-Regular-new.keep-all-layout-features.63.ttf | Bin 6844 -> 6256 bytes
 ...ep-all-layout-features.retain-all-codepoint.ttf | Bin 222212 -> 221620 bytes
 ...fortaa-Regular-new.layout-features.61,62,63.ttf | Bin 7652 -> 7060 bytes
 ...Comfortaa-Regular-new.layout-features.61,63.ttf | Bin 7284 -> 6692 bytes
 .../Comfortaa-Regular-new.layout-features.61.ttf   | Bin 6920 -> 6328 bytes
 .../Comfortaa-Regular-new.layout-features.62.ttf   | Bin 6796 -> 6200 bytes
 .../Comfortaa-Regular-new.layout-features.63.ttf   | Bin 6844 -> 6256 bytes
 ...ar-new.layout-features.retain-all-codepoint.ttf | Bin 219716 -> 219124 bytes
 .../Comfortaa-Regular-new.name-ids.61,62,63.ttf    | Bin 7392 -> 6800 bytes
 .../Comfortaa-Regular-new.name-ids.61,63.ttf       | Bin 7024 -> 6432 bytes
 .../basics/Comfortaa-Regular-new.name-ids.61.ttf   | Bin 6660 -> 6068 bytes
 .../basics/Comfortaa-Regular-new.name-ids.62.ttf   | Bin 6536 -> 5940 bytes
 .../basics/Comfortaa-Regular-new.name-ids.63.ttf   | Bin 6584 -> 5996 bytes
 ...a-Regular-new.name-ids.retain-all-codepoint.ttf | Bin 221264 -> 220668 bytes
 ...mfortaa-Regular-new.name-languages.61,62,63.ttf | Bin 7652 -> 7060 bytes
 .../Comfortaa-Regular-new.name-languages.61,63.ttf | Bin 7284 -> 6692 bytes
 .../Comfortaa-Regular-new.name-languages.61.ttf    | Bin 6920 -> 6328 bytes
 .../Comfortaa-Regular-new.name-languages.62.ttf    | Bin 6796 -> 6200 bytes
 .../Comfortaa-Regular-new.name-languages.63.ttf    | Bin 6844 -> 6256 bytes
 ...lar-new.name-languages.retain-all-codepoint.ttf | Bin 221524 -> 220928 bytes
 .../Comfortaa-Regular-new.name-legacy.61,62,63.ttf | Bin 7652 -> 7060 bytes
 .../Comfortaa-Regular-new.name-legacy.61,63.ttf    | Bin 7284 -> 6692 bytes
 .../Comfortaa-Regular-new.name-legacy.61.ttf       | Bin 6920 -> 6328 bytes
 .../Comfortaa-Regular-new.name-legacy.62.ttf       | Bin 6796 -> 6200 bytes
 .../Comfortaa-Regular-new.name-legacy.63.ttf       | Bin 6844 -> 6256 bytes
 ...egular-new.name-legacy.retain-all-codepoint.ttf | Bin 221524 -> 220928 bytes
 ...mfortaa-Regular-new.notdef-outline.61,62,63.ttf | Bin 0 -> 7652 bytes
 .../Comfortaa-Regular-new.notdef-outline.61,63.ttf | Bin 0 -> 7284 bytes
 .../Comfortaa-Regular-new.notdef-outline.61.ttf    | Bin 0 -> 6920 bytes
 .../Comfortaa-Regular-new.notdef-outline.62.ttf    | Bin 0 -> 6796 bytes
 .../Comfortaa-Regular-new.notdef-outline.63.ttf    | Bin 0 -> 6844 bytes
 ...lar-new.notdef-outline.retain-all-codepoint.ttf | Bin 0 -> 221524 bytes
 .../Comfortaa-Regular-new.retain-gids.61,62,63.ttf | Bin 9656 -> 9068 bytes
 .../Comfortaa-Regular-new.retain-gids.61,63.ttf    | Bin 9300 -> 8708 bytes
 .../Comfortaa-Regular-new.retain-gids.61.ttf       | Bin 8668 -> 8076 bytes
 .../Comfortaa-Regular-new.retain-gids.62.ttf       | Bin 8796 -> 8200 bytes
 .../Comfortaa-Regular-new.retain-gids.63.ttf       | Bin 8852 -> 8260 bytes
 ...egular-new.retain-gids.retain-all-codepoint.ttf | Bin 221568 -> 220972 bytes
 ...ngjo-Regular-subset.notdef-outline.61,62,63.ttf | Bin 0 -> 4128 bytes
 ...yeongjo-Regular-subset.notdef-outline.61,63.ttf | Bin 0 -> 3580 bytes
 ...umMyeongjo-Regular-subset.notdef-outline.61.ttf | Bin 0 -> 3156 bytes
 ...umMyeongjo-Regular-subset.notdef-outline.62.ttf | Bin 0 -> 3180 bytes
 ...umMyeongjo-Regular-subset.notdef-outline.63.ttf | Bin 0 -> 3048 bytes
 ...-subset.notdef-outline.retain-all-codepoint.ttf | Bin 0 -> 9524 bytes
 .../Roboto-Regular.abc.notdef-outline.61,62,63.ttf | Bin 0 -> 2452 bytes
 .../Roboto-Regular.abc.notdef-outline.61,63.ttf    | Bin 0 -> 2260 bytes
 .../Roboto-Regular.abc.notdef-outline.61.ttf       | Bin 0 -> 2048 bytes
 .../Roboto-Regular.abc.notdef-outline.62.ttf       | Bin 0 -> 1916 bytes
 .../Roboto-Regular.abc.notdef-outline.63.ttf       | Bin 0 -> 1972 bytes
 ...lar.abc.notdef-outline.retain-all-codepoint.ttf | Bin 0 -> 2452 bytes
 .../cmap/AdobeBlank-Regular.default.61,62.ttf      | Bin 1336 -> 1252 bytes
 .../cmap/AdobeBlank-Regular.default.61,FEFA.ttf    | Bin 1348 -> 1264 bytes
 .../cmap/AdobeBlank-Regular.default.FEE6,FECF.ttf  | Bin 1300 -> 1216 bytes
 .../cmap/AdobeBlank-Regular.default.FEF9,FEFA.ttf  | Bin 1288 -> 1204 bytes
 .../cmap/AdobeBlank-Regular.default.FEFA.ttf       | Bin 1268 -> 1184 bytes
 ...eBlank-Regular.drop-hints-retain-gids.61,62.ttf | Bin 1552 -> 1468 bytes
 ...lank-Regular.drop-hints-retain-gids.61,FEFA.ttf | Bin 8316 -> 8232 bytes
 ...nk-Regular.drop-hints-retain-gids.FEE6,FECF.ttf | Bin 8188 -> 8104 bytes
 ...nk-Regular.drop-hints-retain-gids.FEF9,FEFA.ttf | Bin 8256 -> 8172 bytes
 ...beBlank-Regular.drop-hints-retain-gids.FEFA.ttf | Bin 8240 -> 8156 bytes
 .../cmap/AdobeBlank-Regular.drop-hints.61,62.ttf   | Bin 1164 -> 1080 bytes
 .../cmap/AdobeBlank-Regular.drop-hints.61,FEFA.ttf | Bin 1176 -> 1092 bytes
 .../AdobeBlank-Regular.drop-hints.FEE6,FECF.ttf    | Bin 1128 -> 1044 bytes
 .../AdobeBlank-Regular.drop-hints.FEF9,FEFA.ttf    | Bin 1116 -> 1032 bytes
 .../cmap/AdobeBlank-Regular.drop-hints.FEFA.ttf    | Bin 1096 -> 1012 bytes
 .../cmap/AdobeBlank-Regular.name-ids.61,62.ttf     | Bin 1084 -> 1000 bytes
 .../cmap/AdobeBlank-Regular.name-ids.61,FEFA.ttf   | Bin 1096 -> 1012 bytes
 .../cmap/AdobeBlank-Regular.name-ids.FEE6,FECF.ttf | Bin 1048 -> 964 bytes
 .../cmap/AdobeBlank-Regular.name-ids.FEF9,FEFA.ttf | Bin 1036 -> 952 bytes
 .../cmap/AdobeBlank-Regular.name-ids.FEFA.ttf      | Bin 1016 -> 932 bytes
 .../cmap/AdobeBlank-Regular.retain-gids.61,62.ttf  | Bin 1724 -> 1640 bytes
 .../AdobeBlank-Regular.retain-gids.61,FEFA.ttf     | Bin 8488 -> 8404 bytes
 .../AdobeBlank-Regular.retain-gids.FEE6,FECF.ttf   | Bin 8360 -> 8276 bytes
 .../AdobeBlank-Regular.retain-gids.FEF9,FEFA.ttf   | Bin 8428 -> 8344 bytes
 .../cmap/AdobeBlank-Regular.retain-gids.FEFA.ttf   | Bin 8412 -> 8328 bytes
 .../Roboto-Regular.default.1FC,21,41,20,62,63.ttf  | Bin 3276 -> 3080 bytes
 .../full-font/Roboto-Regular.default.61,62,63.ttf  | Bin 2864 -> 2672 bytes
 .../Roboto-Regular.default.D7,D8,D9,DA,DE.ttf      | Bin 3216 -> 3024 bytes
 ...oboto-Regular.drop-hints.1FC,21,41,20,62,63.ttf | Bin 1712 -> 1632 bytes
 .../Roboto-Regular.drop-hints.61,62,63.ttf         | Bin 1496 -> 1412 bytes
 .../Roboto-Regular.drop-hints.D7,D8,D9,DA,DE.ttf   | Bin 1728 -> 1648 bytes
 ...ifVariable-Roman.default.1FC,21,41,20,62,63.ttf | Bin 4144 -> 3992 bytes
 .../SourceSerifVariable-Roman.default.61,62,63.ttf | Bin 3984 -> 3832 bytes
 ...eSerifVariable-Roman.default.D7,D8,D9,DA,DE.ttf | Bin 4548 -> 4396 bytes
 ...ariable-Roman.drop-hints.1FC,21,41,20,62,63.ttf | Bin 4120 -> 3968 bytes
 ...urceSerifVariable-Roman.drop-hints.61,62,63.ttf | Bin 3984 -> 3832 bytes
 ...rifVariable-Roman.drop-hints.D7,D8,D9,DA,DE.ttf | Bin 4548 -> 4396 bytes
 .../IndicTestJalandhar-Regular.default.A01.ttf     | Bin 4220 -> 4176 bytes
 .../IndicTestJalandhar-Regular.default.A05,A06.ttf | Bin 4796 -> 4752 bytes
 .../IndicTestJalandhar-Regular.default.A07,A1B.ttf | Bin 4768 -> 4724 bytes
 ...andhar-Regular.default.retain-all-codepoint.ttf | Bin 49288 -> 49244 bytes
 .../IndicTestJalandhar-Regular.drop-hints.A01.ttf  | Bin 1080 -> 1036 bytes
 ...dicTestJalandhar-Regular.drop-hints.A05,A06.ttf | Bin 1388 -> 1344 bytes
 ...dicTestJalandhar-Regular.drop-hints.A07,A1B.ttf | Bin 1388 -> 1344 bytes
 ...har-Regular.drop-hints.retain-all-codepoint.ttf | Bin 29504 -> 29464 bytes
 .../IndicTestJalandhar-Regular.keep-gdef.A01.ttf   | Bin 4220 -> 4176 bytes
 ...ndicTestJalandhar-Regular.keep-gdef.A05,A06.ttf | Bin 4796 -> 4752 bytes
 ...ndicTestJalandhar-Regular.keep-gdef.A07,A1B.ttf | Bin 4768 -> 4724 bytes
 ...dhar-Regular.keep-gdef.retain-all-codepoint.ttf | Bin 49288 -> 49244 bytes
 .../Roboto-Regular.default.1E00,303.ttf            | Bin 2720 -> 2524 bytes
 .../layout.gdef/Roboto-Regular.default.303.ttf     | Bin 2312 -> 2116 bytes
 .../Roboto-Regular.default.309,20,30F.ttf          | Bin 2408 -> 2212 bytes
 .../layout.gdef/Roboto-Regular.default.323.ttf     | Bin 2204 -> 2008 bytes
 .../Roboto-Regular.default.41,42,43.ttf            | Bin 2764 -> 2572 bytes
 .../Roboto-Regular.drop-hints.1E00,303.ttf         | Bin 1464 -> 1380 bytes
 .../layout.gdef/Roboto-Regular.drop-hints.303.ttf  | Bin 1196 -> 1112 bytes
 .../Roboto-Regular.drop-hints.309,20,30F.ttf       | Bin 1256 -> 1172 bytes
 .../layout.gdef/Roboto-Regular.drop-hints.323.ttf  | Bin 1136 -> 1056 bytes
 .../Roboto-Regular.drop-hints.41,42,43.ttf         | Bin 1472 -> 1388 bytes
 .../Roboto-Regular.keep-gdef-gpos.1E00,303.ttf     | Bin 2720 -> 2524 bytes
 .../Roboto-Regular.keep-gdef-gpos.303.ttf          | Bin 2312 -> 2116 bytes
 .../Roboto-Regular.keep-gdef-gpos.309,20,30F.ttf   | Bin 2408 -> 2212 bytes
 .../Roboto-Regular.keep-gdef-gpos.323.ttf          | Bin 2204 -> 2008 bytes
 .../Roboto-Regular.keep-gdef-gpos.41,42,43.ttf     | Bin 2764 -> 2572 bytes
 ...ular.default.627,644,623,62D,644,627,645,2E.ttf | Bin 12724 -> 12684 bytes
 .../Amiri-Regular.default.627,644,62D,628.ttf      | Bin 10028 -> 9992 bytes
 .../Amiri-Regular.default.627,644.ttf              | Bin 4208 -> 4168 bytes
 ...-Regular.default.633,645,627,621,20,644,627.ttf | Bin 9552 -> 9516 bytes
 .../Amiri-Regular.default.63A,64A,631.ttf          | Bin 7360 -> 7324 bytes
 ....retain-gids.627,644,623,62D,644,627,645,2E.ttf | Bin 48052 -> 48012 bytes
 .../Amiri-Regular.retain-gids.627,644,62D,628.ttf  | Bin 42676 -> 42640 bytes
 .../Amiri-Regular.retain-gids.627,644.ttf          | Bin 36736 -> 36696 bytes
 ...ular.retain-gids.633,645,627,621,20,644,627.ttf | Bin 45944 -> 45908 bytes
 .../Amiri-Regular.retain-gids.63A,64A,631.ttf      | Bin 38024 -> 37988 bytes
 ...Bold.default.627,644,623,62D,644,627,645,2E.ttf | Bin 11436 -> 11396 bytes
 ...toNastaliqUrdu-Bold.default.627,644,62D,628.ttf | Bin 18288 -> 18248 bytes
 .../NotoNastaliqUrdu-Bold.default.627,644.ttf      | Bin 3568 -> 3528 bytes
 ...rdu-Bold.default.633,645,627,621,20,644,627.ttf | Bin 12408 -> 12368 bytes
 .../NotoNastaliqUrdu-Bold.default.63A,64A,631.ttf  | Bin 20408 -> 20368 bytes
 ....retain-gids.627,644,623,62D,644,627,645,2E.ttf | Bin 18272 -> 18232 bytes
 ...staliqUrdu-Bold.retain-gids.627,644,62D,628.ttf | Bin 24416 -> 24376 bytes
 .../NotoNastaliqUrdu-Bold.retain-gids.627,644.ttf  | Bin 9216 -> 9176 bytes
 ...Bold.retain-gids.633,645,627,621,20,644,627.ttf | Bin 18212 -> 18172 bytes
 ...toNastaliqUrdu-Bold.retain-gids.63A,64A,631.ttf | Bin 26628 -> 26588 bytes
 .../variable/Fraunces.default.26,66,69,124,125.ttf | Bin 15912 -> 15792 bytes
 .../data/expected/variable/Fraunces.default.61.ttf | Bin 4348 -> 4228 bytes
 test/subset/data/profiles/notdef-outline.txt       |   1 +
 test/subset/data/tests/basics.tests                |   1 +
 test/subset/generate-expected-outputs.py           |   3 +--
 util/options-subset.cc                             |   1 +
 175 files changed, 42 insertions(+), 11 deletions(-)

commit 10ad1859320c0475bdbf706d4b547e1d292c7111
Author: Garret Rieger <grieger@google.com>
Date:   Wed Jun 16 16:34:46 2021 -0700

    [subset] add comment to copy_bytes().

 src/hb-serialize.hh | 2 ++
 1 file changed, 2 insertions(+)

commit 675ebbeb3a0c5b007f87505d6805096a570dd10c
Author: Garret Rieger <grieger@google.com>
Date:   Wed Jun 16 10:40:46 2021 -0700

    [subset] don't alloc zero bytes.
    
    It will be leaked later since hb_blob_create() won't set up the blob to cleanup since it has length zero.

 src/hb-serialize.hh                                        |   2 ++
 ...zz-testcase-minimized-hb-subset-fuzzer-5269686781607936 | Bin 0 -> 48 bytes
 2 files changed, 2 insertions(+)

commit 93e6a9bc4e1ac16abeccc9c0bead08a1eded1540
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jun 15 15:38:49 2021 -0600

    Revert "Remove unneeded buffer clear_output / remove_output calls"
    
    This reverts commit 06175b71433bc42edc07d342e6354035e37fb5fd.
    
    One of the sanitizers is failing. Pushing again as PR to debug.
    I have suspicions.

 src/hb-buffer.cc    | 10 ++++++++++
 src/hb-buffer.hh    |  1 +
 src/hb-ot-layout.cc | 12 ++++++++----
 src/hb-ot-shape.cc  |  3 ++-
 4 files changed, 21 insertions(+), 5 deletions(-)

commit 06175b71433bc42edc07d342e6354035e37fb5fd
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jun 15 14:33:27 2021 -0600

    Remove unneeded buffer clear_output / remove_output calls
    
    Made sure clear_output is always paired with swap_buffers.
    Trying to see if we can move towards RAII-like buffer iterators
    instead of the buffer keeping an iterator internally.

 src/hb-buffer.cc    | 10 ----------
 src/hb-buffer.hh    |  1 -
 src/hb-ot-layout.cc | 12 ++++--------
 src/hb-ot-shape.cc  |  3 +--
 4 files changed, 5 insertions(+), 21 deletions(-)

commit bdfed8f113431a2156e13d59a4b21e19feb7efd9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jun 14 15:46:04 2021 -0600

    [blob] Add failing versions of create API
    
    Fixes https://github.com/harfbuzz/harfbuzz/issues/2567
    
    New API:
    +hb_blob_create_or_fail()
    +hb_blob_create_from_file_or_fail()
    
    Use these in util/ to distinguish empty file from not-found file.
    Only err on the latter.

 docs/harfbuzz-sections.txt          |  2 +
 docs/usermanual-getting-started.xml |  2 +-
 perf/perf-draw.hh                   |  4 +-
 perf/perf-extents.hh                |  4 +-
 perf/perf-shaping.hh                |  8 ++--
 src/hb-blob.cc                      | 89 ++++++++++++++++++++++++++++++-------
 src/hb-blob.h                       | 10 +++++
 src/main.cc                         | 12 ++---
 src/test-buffer-serialize.cc        |  5 ++-
 src/test-gpos-size-params.cc        |  5 ++-
 src/test-gsub-would-substitute.cc   |  5 ++-
 src/test-ot-glyphname.cc            |  5 ++-
 src/test-ot-meta.cc                 |  5 ++-
 src/test-ot-name.cc                 |  5 ++-
 src/test.cc                         |  5 ++-
 test/api/hb-test.h                  |  4 +-
 test/fuzzing/main.cc                | 10 +++--
 util/options.cc                     |  6 +--
 18 files changed, 132 insertions(+), 54 deletions(-)

commit 2fc8d0e6f0b7cfe3897f69ca0411265257dd4a18
Merge: d3dd93630 085aa65e0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jun 15 12:56:17 2021 -0700

    Merge pull request #3020 from googlefonts/serialize_serialize
    
    [subset] Always serialize objects point to by OffsetTo to a new serializer object.

commit 085aa65e09e847cf28d6430e85238ea77cce20e2
Author: Garret Rieger <grieger@google.com>
Date:   Mon Jun 14 16:47:45 2021 -0700

    [subset] Convert offset serialization in gsubgpos and gdef to serialize_serialize().

 src/hb-ot-layout-gdef-table.hh | 6 ++----
 src/hb-ot-layout-gsubgpos.hh   | 6 ++----
 2 files changed, 4 insertions(+), 8 deletions(-)

commit cc96c4e87ee3d5de6364ab207676daf6d243f95b
Author: Garret Rieger <grieger@google.com>
Date:   Mon Jun 14 16:43:23 2021 -0700

    [shaping] Update shaping substituion lookup serialization to use serializer pop()/pack().

 src/hb-ot-layout-gsub-table.hh | 66 +++++++++++++++++++++++++++---------------
 1 file changed, 43 insertions(+), 23 deletions(-)

commit d3dd9363095fadaeb59dabe59b5101bb0ecddb41
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jun 14 12:31:02 2021 -0600

    [coretext] Round position info
    
    Test:
    
    Before:
    $ ./hb-shape /System/Library/Fonts/ヒラギノ丸ゴ\ ProN\ W4.ttc １ --features="+palt" --shaper=coretext
    [gid781=0@-78,0+841]
    $ ./hb-shape /System/Library/Fonts/ヒラギノ丸ゴ\ ProN\ W4.ttc １ --features="+palt" --shaper=ot
    [gid781=0@-78,0+842]
    
    After:
    $ ./hb-shape /System/Library/Fonts/ヒラギノ丸ゴ\ ProN\ W4.ttc １ --features="+palt" --shaper=coretext
    [gid781=0@-78,0+842]
    $ ./hb-shape /System/Library/Fonts/ヒラギノ丸ゴ\ ProN\ W4.ttc １ --features="+palt" --shaper=ot
    [gid781=0@-78,0+842]
    
    I've verified in the font that 842 is correct.

 src/hb-coretext.cc | 12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

commit 8443cc85cb118e858043179ac27673ce170dad3b
Author: Garret Rieger <grieger@google.com>
Date:   Fri Jun 11 13:40:39 2021 -0700

    [subset] Correct OffsetTo serialization in GPOS to use serialize_serialize ().

 src/hb-ot-layout-gpos-table.hh | 30 +++++++++++-------------------
 1 file changed, 11 insertions(+), 19 deletions(-)

commit 5ba46ed067a04b6e1de1611153885c2478de3ceb
Author: Garret Rieger <grieger@google.com>
Date:   Fri Jun 11 13:34:00 2021 -0700

    [subset] Correct OffsetTo serialization in GSUB to use serialize_serialize ().

 src/hb-ot-layout-gsub-table.hh | 44 +++++++++++++++++++-----------------------
 1 file changed, 20 insertions(+), 24 deletions(-)

commit 35458b6b66f801194a1dad957308be9a71280425
Author: Garret Rieger <grieger@google.com>
Date:   Fri Jun 11 13:14:51 2021 -0700

    [subset] Add serialize_serialize to OffsetTo.
    
    Similar to serialize_subset() this will serialize the new object and then link it to the offset.

 src/hb-open-type.hh            | 17 +++++++++++++++++
 src/hb-ot-layout-gsub-table.hh |  2 +-
 2 files changed, 18 insertions(+), 1 deletion(-)

commit 2b0ced28b685de4edbd22cf5f59be30075984dfb
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Jun 9 19:06:31 2021 -0600

    Cluster Regional_Indicator pairs (aka emoji flags)
    
    Fixes https://github.com/harfbuzz/harfbuzz/issues/2265

 src/hb-ot-shape.cc | 8 ++++++++
 1 file changed, 8 insertions(+)

commit 4e72d5e35d68b1772985ddafc522dcd4b0aceec2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Jun 13 05:46:17 2021 -0600

    [src/check-static-init] Ignore objdump "file format not recognized" error
    
    Fixes https://github.com/harfbuzz/harfbuzz/issues/3019

 src/check-static-inits.py | 17 +++++++++++++++--
 1 file changed, 15 insertions(+), 2 deletions(-)

commit 5bc05ba155a0fd568b56423009e55d16ed42b91c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Jun 13 05:28:20 2021 -0600

    Prefer GPOS over kerx, if GSUB was applied
    
    Fixes https://github.com/harfbuzz/harfbuzz/issues/3008

 src/hb-ot-shape.cc                           | 6 ++++--
 test/shaping/data/in-house/tests/macos.tests | 3 +++
 2 files changed, 7 insertions(+), 2 deletions(-)

commit 13c6ad980fcff52567955d268f33d698ff78379e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Jun 12 11:00:19 2021 -0600

    [src/check-*] Pickup $(NM), $(OBJDUMP), $(LDD), $(OTOOL)
    
    Fixes https://github.com/harfbuzz/harfbuzz/issues/3019

 src/Makefile.am            |  4 ++++
 src/check-libstdc++.py     | 14 ++++++--------
 src/check-static-inits.py  |  4 ++--
 src/check-symbols.py       |  6 +++---
 src/gen-ragel-artifacts.py |  4 ++--
 5 files changed, 17 insertions(+), 15 deletions(-)

commit c61ce962cfdef3fc756850132eb9f76cb7a57ba5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jun 10 17:33:29 2021 -0600

    [buffer] In hb_buffer_get_positions(), return NULL if inside message callback
    
    As discussed in https://github.com/harfbuzz/harfbuzz/issues/2468#issuecomment-645666066
    
    Part of fixing https://github.com/harfbuzz/harfbuzz/issues/2468

 src/hb-buffer.cc | 16 +++++++++++++---
 src/hb-buffer.hh |  9 +++++++++
 util/options.cc  |  2 +-
 3 files changed, 23 insertions(+), 4 deletions(-)

commit 855a3f478eea5b770e64611d09fd347336c56b67
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Jun 9 15:10:52 2021 -0600

    [emoji] Fix emoji table generation
    
    Previously, the last of each range having Extended_Pictograph property
    was not processed as so. Ouch!
    
    Test:
    
    $ echo x > null; hb-shape null -u U+1f43b,U+200d,U+2744,U+fe0f
    
    Before:
    [gid0=0+1000|gid0=2+1000]
    
    After:
    [gid0=0+1000|gid0=0+1000]
    
    Caught by https://github.com/harfbuzz/harfbuzz/issues/3017

 src/gen-emoji-table.py        |  2 +-
 src/hb-unicode-emoji-table.hh | 64 +++++++++++++++++++++++--------------------
 2 files changed, 36 insertions(+), 30 deletions(-)

commit bd5502f09f09b3f464754395880f9db30a5fcf60
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Jun 9 14:03:25 2021 -0600

    [set] Oops. Fix compile

 src/hb-set.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3962225a7247582f1ae12193a4caee11dc876e1e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Jun 9 14:02:31 2021 -0600

    [set] Add hb_set_copy()
    
    Fixes https://github.com/harfbuzz/harfbuzz/issues/3016

 docs/harfbuzz-sections.txt |  1 +
 src/hb-set.cc              | 18 ++++++++++++++++++
 src/hb-set.h               |  3 +++
 3 files changed, 22 insertions(+)

commit bc33b87f5e72648c66949cc9469291e77aa80701
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Jun 9 11:51:32 2021 -0600

    [set] Use references, not pointers, in internal C++ API

 src/hb-ot-layout-gsubgpos.hh |  2 +-
 src/hb-set.cc                | 14 ++++-----
 src/hb-set.hh                | 69 ++++++++++++++++++++++----------------------
 src/hb-subset-plan.cc        |  2 +-
 4 files changed, 44 insertions(+), 43 deletions(-)

commit 9cfac093aa5816113289812764c44ec0c44c04c4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Jun 9 11:41:59 2021 -0600

    [set] Add copy constructor/assignment

 src/hb-set.hh | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit a83b9b0fec4c21e9da19b7c83ea76cb33aabd195
Merge: 4811e8f5d 6119ff9d8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jun 7 16:41:27 2021 -0700

    Merge pull request #3011 from harfbuzz/directwrite-cleanup
    
    Some directwrite cleanups

commit 4811e8f5d76ef528b4cec00f241cc4ab8110db30
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Mon Jun 7 10:54:36 2021 +0200

    Trigger doc rebuild

 src/hb-face.cc | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit 09a2eb65d782c1e6bba5ebb5027eaf84c40fc31a
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Mon Jun 7 10:52:27 2021 +0200

    Revert "Temporarily always push the docs commit"
    
    This reverts commit 6612fd39ae6f84446dad1b0507417d6febf22fa0.

 .ci/deploy-docs.sh | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 6612fd39ae6f84446dad1b0507417d6febf22fa0
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Mon Jun 7 10:36:02 2021 +0200

    Temporarily always push the docs commit

 .ci/deploy-docs.sh | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit b39b047505d0cd8a77fb9eafca2a08b717a07ead
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Mon Jun 7 10:27:33 2021 +0200

    Try to fix doc deployment
    
    https://github.com/harfbuzz/harfbuzz.github.io/issues/4
    
    From CI logs at https://github.com/harfbuzz/harfbuzz/runs/2758234200:
    
    + git init
    hint: Using 'master' as the name for the initial branch. This default branch name
    hint: is subject to change. To configure the initial branch name to use in all
    hint: of your new repositories, which will suppress this warning, call:
    hint:
    hint:   git config --global init.defaultBranch <name>
    hint:
    hint: Names commonly chosen instead of 'master' are 'main', 'trunk' and
    hint: 'development'. The just-created branch can be renamed via this command:
    hint:
    hint:   git branch -m <name>
    
    We want the branch too be main not master.

 .ci/deploy-docs.sh | 1 +
 1 file changed, 1 insertion(+)

commit 5585ea02eb90c013ddba73290d3a9ae435df9f15
Author: David Corbett <corbett.dav@northeastern.edu>
Date:   Sat Jun 5 08:35:28 2021 -0400

    [syllabic] Set position of dotted circle for Indic

 src/hb-ot-shape-complex-indic.cc                          |   3 ++-
 src/hb-ot-shape-complex-syllabic.cc                       |   5 ++++-
 src/hb-ot-shape-complex-syllabic.hh                       |   3 ++-
 .../fonts/fd07ea46e4d8368ada1776208c07fd596f727852.ttf    | Bin 0 -> 956 bytes
 test/shaping/data/in-house/tests/cluster.tests            |   1 +
 5 files changed, 9 insertions(+), 3 deletions(-)

commit a9fb6a0c3cb1ffdbd6c18c8a4b1ad7a51ade2e1c
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Sun Jun 6 14:40:50 2021 +0200

    [aat] Add start table/end table to buffer messages
    
    Related to https://github.com/harfbuzz/harfbuzz/issues/3008

 src/hb-aat-layout.cc | 6 ++++++
 src/hb-ot-layout.cc  | 2 ++
 2 files changed, 8 insertions(+)

commit 19cb449358202b22b851f87032ea01b950b04f0f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Jun 5 13:44:51 2021 -0600

    Update COPYING
    
    Mainly just to push any commit to see if it fixes our github.io site.
    
    https://github.com/harfbuzz/harfbuzz.github.io/issues/4

 COPYING | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit cf9538e8080c6e96c840db09515191a799c85de9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jun 4 22:33:16 2021 -0600

    Removal remaining uses of "blacklist" terminology

 src/gen-use-table.py | 4 ++--
 src/hb-config.hh     | 2 +-
 src/hb-ot-layout.cc  | 6 +++---
 3 files changed, 6 insertions(+), 6 deletions(-)

commit 6119ff9d806db7de3ceef73de67fe589507800bb
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Thu Jun 3 13:02:53 2021 +0200

    [hb-directwrite] Don't load dwrit.dll dynamically
    
    We already link to it, so I don't see the point of trying to load it
    dynamically.

 src/hb-directwrite.cc | 36 ++----------------------------------
 1 file changed, 2 insertions(+), 34 deletions(-)

commit b2070a509c6aabc5a275749979d140f8d78206e6
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Thu Jun 3 10:50:46 2021 +0200

    [hb-directwrite] Don’t override new/delete
    
    This is a testing shaper, we don’t care for overridden malloc/free here.
    Use malloc/free in the code called from hb_directwrite_face_create().

 src/hb-directwrite.cc | 14 ++------------
 1 file changed, 2 insertions(+), 12 deletions(-)

commit 221d642b196a1bc1550e06a06d32bc8888590380
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Thu Jun 3 10:45:23 2021 +0200

    [hb-directwrite] Remove _hb_directwrite_shape_experimental_width
    
    Not used anywhere.

 src/hb-directwrite.cc | 128 +++-----------------------------------------------
 1 file changed, 6 insertions(+), 122 deletions(-)

commit fa432a121e3c409de77cd2e2b1085b31b93be4c6
Author: Khaled Hosny <khaled@aliftype.com>
Date:   Sat Jun 5 04:06:58 2021 +0200

    Rename various references to master branch

 .ci/deploy-docs.sh             | 4 ++--
 .github/workflows/linux-ci.yml | 6 +++---
 .github/workflows/msvc-ci.yml  | 4 ++--
 .github/workflows/msys2-ci.yml | 4 ++--
 README                         | 8 ++++----
 README.md                      | 4 ++--
 6 files changed, 15 insertions(+), 15 deletions(-)

commit 35d6af69435ff070cee00f7cd9741b3545ca161c
Author: Qunxin Liu <qxliu@google.com>
Date:   Fri Jun 4 10:04:27 2021 -0700

    [subset] fix fuzzer testcase: https://oss-fuzz.com/testcase-detail/5965777994907648

 src/hb-ot-color-colr-table.hh                            |  15 +++++++++++++--
 ...-testcase-minimized-hb-subset-fuzzer-5965777994907648 | Bin 0 -> 159 bytes
 2 files changed, 13 insertions(+), 2 deletions(-)

commit 92206345a390311e6ebe074238bf39d6dc77d79e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jun 4 14:51:49 2021 -0600

    [ci] Disable patch-level codecov failures
    
    Fixes https://github.com/harfbuzz/harfbuzz/issues/3004

 .codecov.yml | 1 +
 1 file changed, 1 insertion(+)

commit 3d48bfc18731e3c2187a5b0666a7e94dcab0150b
Author: Peter Williams <peter@newton.cx>
Date:   Wed Jun 2 23:12:53 2021 -0400

    Avoid a deprecation warning in graphite2
    
    As of graphite2 1.3.7, `gr_make_face` is deprecated in favor of
    `gr_make_face_with_ops`. It's a one-liner to port over to using it.
    
    This is potentially a compatibility break since I'm not sure when the
    `with_ops` API was added, but the minimum version of graphite2 that's
    supported by Harfbuzz doesn't seem to be documented anywhere anyway.

 src/hb-graphite2.cc | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 1b6008ca625e0f41cb34259368f91677a110b5dd
Author: Qunxin Liu <qxliu@google.com>
Date:   Wed Jun 2 15:07:18 2021 -0700

    fix fuzzer testcase: https://oss-fuzz.com/testcase-detail/5417934246772736
